/**
 * Controller for a single choiceless segment.
 * 
 * Capabilities:
 * -unset
 * -continue
 * -continued
 * 
 * @param {string} id The id of the scene.
 * @param {string} key The key of this choice.
 */
function ContinueController(id, key) {
    this.continue = function () {
        global.kobold.history.setKey(id, key, true);
    };
    this.continued = function () {
        return global.kobold.history.has(id, key);
    };
    this.unset = function () {
        global.kobold.history.unsetKey(id, key);
    };
}