/**
 * This JavaScript file contains code that will be called upon the start of 
 * Kobold Adventure.
 */

$(document).ready(function () {
    // Initialize everything.
    global.init();

    // Hotload if required.
    global.hotLoader.hotLoadIfRequired();

    // After hotloading, continue intialization.
    global.hotLoader.loaded.then(function () {

        // Allow scene registration.
        global.sceneLoader.registerStart();

        // Load initial scene.
        global.sceneLoader.loadScene("TitleScreen");

        // Initial autosave.
        if (!global.saveManager.hasAutoSave()) {
            global.saveManager.autoSave();
        }

        // Initial start game save.
        global.saveManager.newGameSave();

        // Hide loading screen.
        global.ui.hideLoadingScreen();

        // If hotloading fails: show what happened.
    }, function (reason) {
        alert(reason);
    });
});
