/**
 * Hide section of the woods.
 * @param {ForestController} controller The Forest controller.
 */
function ForestWoodsRunFail(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstChoice = new ForestWoodsRunFailStruggle(ctrl);
    var secondChoice = new ForestWoodsRunFailBeg(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var weapon = ctrl.misc.weapon();
        var bra = ctrl.misc.bra();
        var pants = ctrl.misc.pants();
        var underwear = ctrl.misc.underwear();
        global.kobold.history.shared.enslavement.captured = true;
        var toReturn = `[p]
                            Your very life at stake, you line yourself up perfectly with the piece of wood blocking your path.
                            You're only going to get [b]one[/b] shot at this.
                            Succeed, and you can escape through the copse, and hopefully make it home by nightfall.
                            If you fail, the wolf'll catch up to you, and who knows what he'll do?
                        [/p]`;

        if (ctrl.run.get() === ForestWoodsRunChoice.BREAKTHROUGH) {
            toReturn += `[p]
                            You [b]storm[/b] towards the barring branch,
                            digging your claws into the dirt below to add an extra ounce of sheer [b]power[/b] to your barreling form.
                            Gritting your teeth, you [b]ram[/b] into the wooden barricade with [b]all[/b] of your might.
                            The blockade creaks loudly, but it does not break.
                            Instead of ramming through it like you intended,
                            the branch [b]smacks[/b] into your gut like a wooden mace,
                            your own momentum turned back on you with a force strong enough to knock you off your feet and onto your back.
                        [/p]`;
        } else {
            toReturn += `[p]
                            You [b]rush[/b] towards the barring branch,
                            eyeing the small clearance below it, envisioning yourself sliding underneath the it and emerging safely on the other side. 
                            Waiting until the very last moment, you let your upper body drop to the ground, gliding feet-first underneath the barricade.
                            Alas, you tilt your head up just a [i]little[/i] too high, and end up smacking face-first into the wooden barrier,
                            your entire sliding body coming to a halt.
                        [/p]`;
        }

        toReturn += `   [p]
                            The heavy blow is enough to daze you for a while.
                            As you lay motionlessly on your back, trying to collect your senses,
                            the wolf pursuing you approaches your downed form.
                            As the worst of the blurriness fades from your eyes,
                            his broad figure looming over you comes into view.
                        [/p]
                        [p]
                            Panic clouds your mind.
                            You attempt to crawl underneath the branch, to escape still,
                            but all the big man has to do to stop you is plant his hefty, black-furred footpaw directly ontop of your chest,
                            like a hunter standing over freshly felled prey.
                            You wildly flail about, writhing around your entire body like a [b]child[/b] trying,
                            but failing to get away from righteous parental punishment.
                            All the seemingly calm lupine has to do to get you to stop, is pressing his clawed toes against your scaly abdomen,
                            the simple, minimalistic act wordlessly conveying a threat to [b]tear your guts out[/b] unless you stop squirming.
                        [/p]
                        [p]
                            Once you've calmed a bit, the black wolf reaches down.
                            Grabbing you by your throat, he removes his foot from your chest,
                            picking you up and lifting you off the ground by your very neck instead of pinning you to the forest floor.
                            ${weapon ? `You try to swing your ${global.kobold.inventory.createItemWithTooltip(weapon)}, but accidentally drop it to the floor.` : ``}
                            With his free hand, he deftly snags and pockets your ill-gotten coinpouch.
                            Then, he produces an odd, iron object, the likes of which you've only ever seen worn by slaves.
                            [i]Oh no.[/i]
                        [/p]
                        [p]
                            He brings the ferrous collar to your throat, and with a loud, metallic [i]click[/i], it wraps around your neck.
                            "[color=gblue]For the crime of thievery...[/color]" the wolf speaks in a bass voice.
                            "[color=gblue]...and for making me run halfway through the fucking forest...[/color]" he continues, sounding a lot more disgruntled than before.
                            "[color=gblue]...you are now the property of Furskin Mountain-Crew.[/color]"
                            The Furskin Mountain-Crew.
                            But those are bandits, from [i]way[/i] up north.
                            What are they doing guarding caravans coming from the south?!
                            Lack of air from the furred hand squeezing your throat shut getting to you, your train of thoughts goes amiss.
                        [/p]
                        [p]
                            The canine clears his throat, seemingly only now having fully recovered from the chase.
                            "[color=gblue]Normally, this is where I'd tell you you've just lost all of your rights.[/color]"
                            He gives you a sly wink.
                            "[color=gblue]But you never had any to begin with, now did you?[/color]"
                            The wolf wickedly chuckles at his own sadistic joke,
                            his face returning to a dead-serious glare as he realizes you [i]aren't[/i] sharing his jolly sentiment.
                            You're stuck between barely being able to breath,
                            and trying to process the fact that your entire future is now in the hands of the bandit holding you,
                            or whatever misfits he may call his [i]friends[/i].
                        [/p]
                        [p]
                            With a loud growl, the hulking brute [b]slams[/b] your back against a nearby tree,
                            lifting you up high enough to come face-to-face with him.
                            His free hand moves to your chest, where he ${bra ? `uses one of his claws to slowly shred
                            your ${global.kobold.inventory.createItemWithTooltip(bra)} into tiny little bits` : `slowly runs one of his claws in circles atop your scales`}.
                            The lupine grins wickedly.
                            "[color=gblue]You know, I've always wanted a kobold [b]slave[/b].[/color]"
                            His hand roams ever-lower, claw trailing over your soft belly, down towards your groin.
                            "[color=gblue]Guarding these [b]stupid[/b] transports gets lonely at times, especially [i]at night[/i].[/color]"
                            With a single, firm tug, he [b]tears[/b] apart your
                            ${pants ? `${global.kobold.inventory.createItemWithTooltip(pants)}` : `${global.kobold.inventory.createItemWithTooltip(underwear)}`},
                            your last bastion of modesty ripped away from you.
                            "[color=gblue]Caravan master may want to sell you, but that won't stop me from [i]testing the merchandise[/i] first.[/color]"
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = ctrl.runFail.has() ? "disabled" : "";
        var isSelected = ctrl.runFail.get() === ForestWoodsRunFailChoice.STRUGGLE;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Struggle</button>`;

        var tooltip = global.parser.parse(`The wolf's intentions are clear. That doesn't mean you're going to make it easy for him.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = ctrl.runFail.has() ? "disabled" : "";
        var isSelected = ctrl.runFail.get() === ForestWoodsRunFailChoice.BEG;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Beg</button>`;

        var tooltip = global.parser.parse(`Use your mind instead of your body to resist. Beg, lie and panhandle your way out of this.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.runFail.set(ForestWoodsRunFailChoice.STRUGGLE);
            loadNextPart(firstChoice);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.runFail.set(ForestWoodsRunFailChoice.BEG);
            loadNextPart(secondChoice);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.runFail.change();
        part += buildChoice();
        part += `</div>`;
        part += firstChoice.build();
        part += secondChoice.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        firstChoice.registerListeners();
        secondChoice.registerListeners();

        if (ctrl.runFail.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var ForestWoodsRunFailChoice = {
    STRUGGLE: 1,
    BEG: 2
};
