/**
 * Hide section of the woods.
 * @param {ForestController} controller The Forest controller.
 */
function ForestWoodsRunFailBeg(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            The wolf sets you back down on the ground, to give you a few seconds to catch your breath.
                            You [b]beg[/b] and you [b]plead[/b] and you [b]cry[/b] for mercy.
                            You didn't know you were stealing from the [i]mighty[/i] [b]Furskin Mountain-Crew[/b]!
                            If you'd seen a [b]strong[/b] and [b]imposing[/b] black wolf like him guarding the caravan,
                            you'd have thought twice before attempting to rob it!
                            Surely, a man so big has room for a bit of [b]kindness[/b] in his heart, right?!
                        [/p]
                        [p]
                            Your flattery seems to fall on deaf ears.
                            The wolf undoes his pants, his swollen sheath coming into view, the tapered tip of his member already protruding from it.
                            Panicking, your brain works overtime to think of [i]something[/i], [b]anything[/b] that could save you now.
                            If you can't get him to let you go, surely you can convince the canine to keep his hands off of you, for now, right?!
                            Then it hits you.
                            Yes.
                            This might work.
                        [/p]
                        [p]
                            You loudly cry for the wolf to [b]stop[/b]!
                            You're a [b]virgin[/b]!
                            Virgin slaves sell for [b]a lot[/b] more!!
                            If he takes you back to his leader [i]without[/i] touching you, surely he'll be rewarded with enough coin to buy at least [b]two[/b] whores.
                            He knows of the legendary Varanarian brothel district, right?!
                        [/p]
                        [p]
                            Your new ploy seems to be working.
                            The lupine stops to consider his actions.
                            With a loud sigh, he buttons up  his pants once more.
                            He stares into your eyes, hatred clearly visible on his face.
                            Baring his teeth, he growls loudly.
                            "[color=gblue]Better not be lying.[/color]" he speaks in an angry tone.
                            "[color=gblue]About the whores [b]or[/b] your virginity.[/color]"
                        [/p]
                        [p]
                            The sun is slowly starting to set.
                            The upset canine takes one last lusting glance at your naked form.
                            Letting go of your throat, he grabs you by your new collar.
                            And thus, you are forcibly dragged throughout the forest by your new [i]captor[/i],
                            back towards the caravan where today's adventure began.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(ctrl.enslaveSceneName, ctrl.enslaveFolder);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.runFail.get() !== ForestWoodsRunFailChoice.BEG) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.beg.change();
        part += buildChoice();
        if (!ctrl.enslaveReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.runFail.get() !== ForestWoodsRunFailChoice.BEG) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (ctrl.enslaveReady) {
            registerContinueListener();
        }
    };
}
