/**
 * Confrontation section of Varanar, Night Two.
 * @param {NightTwoController} controller The Night Two controller.
 */
function NightTwoCrudeReluctant(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new NightTwoCrudeReluctantContinue(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.nightTwo.buttKiss = true;
        var toReturn = `[p]
                            You try your hardest to look for a way out of this mess you've created, but your brain draws a blank.
                            It seems as though you've talked yourself into a corner.
                            You can simply [i]refuse[/i] to play along, but judging by the group's intense behavior,
                            you can make a pretty decent guess that things [b]won't[/b] turn out nicely if you back out now.
                            The best course of action, for now, would be to just [i]play along[/i].
                            If you do ask they ask of you, this'll all be over soon...you hope.
                        [/p]
                        [p]
                            "[color=bred]Well? Don't keep me waiting.[/color]" the half-naked human's voice snaps you back to reality.
                            He bends over slightly, his unsavory ass jutting out towards you.
                            You can feel your stomach churning.
                            It's just so [b]hairy[/b] and [b]disgusting[/b].
                            You'd rather kiss a [b]horse[/b]'s rear end.
                            You [b]really[/b] don't want to do this, but the men have left you with little choice.
                        [/p]
                        [p]
                            You sigh loudly and take a deep breath of cool, late-night air.
                            Your lungs filled with clean air, you drop to your knees, and hold your breath.
                            Closing your eyes, you lean forwards, and plant a single small kiss on the human's right buttcheek,
                            your snout pressing against his damp skin.
                            As you pull back from the simple peck, the group bursts out into laughter.
                        [/p]
                        [p]
                            You are completely disgusted.
                            You wipe off the sweat clinging to the front of your muzzle.
                            Rising to your feet once more, an intense feeling of [b]sickness[/b] washes over you.
                            You heave, retch and gag.
                            It's like you're on the verge of vomiting, without being able to hurl and get it over with already.
                            All the while, the humans are taunting you.
                            "[color=green]The lizard actually did it![/color]"
                            "[color=brown]You kiss your mother with that mouth?![/color]"
                            "[color=purple]Ass-kissing kobold![/color]"
                            "[color=dred]Bet it tastes better than what you're used to eating![/color]"
                        [/p]
                        [p]
                            The exposed man pulls up his pants.
                            While the crowd slowly simmers down, he addresses his comrade.
                            "[color=bred]Told you they were good at something, Jacoby.
                            You owe us a round at the tavern![/color]"
                            The group bursts into cheer.
                            Pushing you aside, they break their encircling formation, and wander off towards the brothel district you came from,
                            leaving you alone in the street, struggling to overcome your sheer revulsion.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = ctrl.crudeReluctant.continued() ? "disabled" : "";
        var isSelected = ctrl.crudeReluctant.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.crudeReluctant.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.appease.get() !== NightTwoCrudeAppeaseChoice.RELUCTANT) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.crudeReluctant.change();
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.appease.get() !== NightTwoCrudeAppeaseChoice.RELUCTANT) {
            return;
        }

        next.registerListeners();

        if (ctrl.crudeReluctant.continued()) {
            return;
        }

        registerNextListener();
    };
}
